<?php
/**
 * The new feature popup in admin settings page
 *
 * @link       https://themehigh.com
 * @since      1.0.0
 *
 * @package    woocommerce-email-customizer-pro
 * @subpackage woocommerce-email-customizer-pro/admin
 */
if(!defined('WPINC')){	die; }

if(!class_exists('THWEC_Admin_Settings_Popup')):

class THWEC_Admin_Settings_Popup{

	public function render_popup(){
		$dismiss_url = add_query_arg($this->get_dismiss_url());
		$explore_url = add_query_arg( $this->get_dismiss_url(), admin_url('admin.php?page=th_email_customizer_integrations'));
		?>
		<div id="thwec_new_features_modal" class="thwec-feature-popup" style="display: none;">
			<div class="thwec-new-features-modal">
				<div class="thwec-feature-popup-close">
					<a class="thwec-feature-popup-close-link" href="<?php echo esc_url($dismiss_url); ?>"><img src="<?php echo THWEC_URL ?>/admin/assets/images/close-feature-popup.png" /></a>
				</div>
				<div class="thwec-feature-slider-1 thwec-feature-slider">
					<div class="thwec-feature-slider-image"></div>
					<div class="thwec-feature-slider-content">
						<p class="thwec-feature-slider-intro">Manage compatible plugins in clicks now.</p>
						<p class="thwec-feature-slider-title">Managing 3rd party plugins got Easy!</p>
						<p class="thwec-feature-slider-subtitle">Get the new Integration page in your menu. Activate/deactivate and control all compatible 3rd party plugins better.</p>
					</div>
				</div>
				<div class="thwec-feature-slider-2 thwec-feature-slider thwec-slider-active">
					<div class="thwec-feature-slider-image"></div>
					<div class="thwec-feature-slider-content">
						<p class="thwec-feature-slider-intro">We are now compatible with your favorite plugins, with no additional charges.</p>
						<p class="thwec-feature-slider-title">More compatibility more usability</p>
						<p class="thwec-feature-slider-subtitle">Now compatible with Woocommerce B2B. Our list of compatible plugins is just adding up. Get, set and create more while we keep working to give you best integrations.</p>
						<a class="button btn thwec-feature-popup-explore" href="<?php echo esc_url($explore_url); ?>">Explore</a>
					</div>
				</div>
				<div class="thwec-feature-modal-slide-control">
					<span class="thwec-slider-dot" data-count="1"></span> 
					<span class="thwec-slider-dot thwec-active-dot" data-count="2"></span> 
				</div>
			</div>
		</div>
		<?php
	}

	private function get_dismiss_url(){
		return array('thwec_dissmis_popup' => true, 'thwec_feature_popup_nonce' => wp_create_nonce( 'thwec_feature_popup_security'));
	}
}

endif;